arkdep/arkdep-build

350 lines
13 KiB
Text
Raw Normal View History

2023-06-21 18:36:52 +02:00
#!/usr/bin/env bash
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
## Common functions
#
# Cleanup and quit if error
cleanup_and_quit () {
# If any paramters are passed we will assume it to be an error
2023-06-22 02:27:51 +02:00
[[ -n $1 ]] && printf "\e[1;31m<#>\e[0m $*\e[0m\n" >&2
2023-06-21 18:36:52 +02:00
2024-02-24 05:36:24 +01:00
if [[ $ARKDEP_NO_CLEANUP -eq 1 ]]; then
printf 'Cleanup disabled, not running cleanup\n'
exit 1
fi
2024-05-02 09:03:41 +02:00
umount -Rl $build_image_mountpoint
2023-09-10 08:26:43 +02:00
2024-05-01 00:11:01 +02:00
rm $build_image
rm -rf $build_image_mountpoint
2023-06-21 18:36:52 +02:00
# Quit program if argument provided to function
2024-02-22 07:45:21 +01:00
if [[ -n $1 ]]; then
exit 1
fi
2023-06-21 18:36:52 +02:00
# Otherwise just quit, there is no error
exit 0
}
## Set common variables
#
2024-05-01 00:11:01 +02:00
declare -r build_image='/var/tmp/arkdep-build.img'
declare -r build_image_mountpoint='/var/tmp/arkdep-build'
declare -r workdir="$build_image_mountpoint/rootfs"
declare -r variant="$1"
2024-05-01 00:11:01 +02:00
declare -r build_image_size='15G'
2024-02-22 07:45:21 +01:00
2024-05-08 07:08:19 +02:00
# Minimum required storage in KiB
declare -r minimum_available_root_storage='31457280' # 30G
declare -r minimum_available_var_storage='20971520' # 20G
2024-02-22 07:45:21 +01:00
if [[ -v ARKDEP_CONFIGS ]]; then
declare -r configsdir="$ARKDEP_CONFIGS"
else
declare -r configsdir="$(readlink -m ./arkdep-build.d/)"
fi
2024-03-09 03:40:07 +01:00
# Before we continue setting variables, lets first ensure the configsdir actually exist
# We do this now to give better error reporting to the user
if [[ ! -d $configsdir ]]; then
printf "\e[1;31m<#>\e[0m\e[1m $configsdir does not exist, are you located inside of the configuration directory's parent directory?\n\e[0m"
exit 1
fi
2024-02-22 07:45:21 +01:00
declare -r variantdir="$configsdir/$variant"
2024-03-09 03:40:07 +01:00
declare -r type="$(cat $(readlink -m $variantdir/type) 2> /dev/null || (printf '\e[1;31m<#>\e[0m\e[1m Failed to get build type\n\e[0m'; exit 1))"
2024-02-22 07:45:21 +01:00
if [[ -v ARKDEP_OUTPUT_TARGET ]]; then
declare -r output_target="$ARKDEP_OUTPUT_TARGET"
else
2024-05-02 09:00:27 +02:00
declare -r output_target="$(pwd)/target"
2024-02-22 07:45:21 +01:00
fi
2024-02-22 07:45:21 +01:00
## Set common functions
#
# Generate a 42 character long random string, used for generating psuedo-random image names
# Unless overwritten with $ARKDEP_CUSTOM_NAME
2023-08-11 08:04:36 +02:00
gen_random_string () {
if [[ -v ARKDEP_CUSTOM_NAME ]]; then
random=$ARKDEP_CUSTOM_NAME
else
random=$(openssl rand -hex 100 | head -c 42)
fi
2023-08-11 08:04:36 +02:00
printf "${random}\n"
}
2024-04-27 04:55:47 +02:00
declare -r image_name=$(gen_random_string)
2023-06-21 18:36:52 +02:00
## Error checking
#
# Quit if not root
2024-02-22 07:45:21 +01:00
if [[ ! $EUID -eq 0 ]]; then
2024-03-09 03:40:07 +01:00
printf '\e[1;31m<#>\e[0m\e[1m This program has to be run as root\n\e[0m'
2023-06-21 18:36:52 +02:00
exit 1
2024-02-22 07:45:21 +01:00
fi
2023-06-21 18:36:52 +02:00
# Check if all dependencies are installed, quit if not
for prog in btrfs pacstrap; do
if ! command -v $prog > /dev/null; then
2023-06-22 02:27:51 +02:00
printf "\e[1;31m<#>\e[0m\e[1m Failed to locate $prog, ensure it is installed\e[0m\n"
2023-06-21 18:36:52 +02:00
exit 1
fi
done
# Check if requested variant exists
2024-02-22 07:45:21 +01:00
if [[ ! -d $variantdir ]]; then
2024-03-09 03:40:07 +01:00
printf '\e[1;31m<#>\e[0m\e[1m The requested variant does not exist\e[0m\n'
2023-06-21 18:36:52 +02:00
exit 1
2024-02-22 07:45:21 +01:00
fi
2023-06-21 18:36:52 +02:00
2024-05-08 07:08:19 +02:00
# Run the storage check only if we are not building a migration
2024-05-24 03:39:28 +02:00
if [[ $type != 'migration' ]]; then
2024-05-08 07:08:19 +02:00
# Ensure we have the required storage available on both /var/tmp and root
declare root_storage_available=($(df --output=avail /))
root_storage_available=${root_storage_available[1]}
declare var_storage_available=($(df --output=avail /var/tmp))
var_storage_available=${var_storage_available[1]}
2024-05-08 07:08:19 +02:00
if [[ $root_storage_available -lt $minimum_available_root_storage ]]; then
printf 'Not enough storage available on root to export image\n'
exit 1
fi
if [[ $var_storage_available -lt $minimum_available_var_storage ]]; then
printf 'Not enough storage available on var to create image\n'
exit 1
fi
fi
2023-06-22 01:53:19 +02:00
## Variants
#
2024-04-27 04:55:47 +02:00
# Build migration type image
if [[ $type == 'migration' ]]; then
printf '\e[1;34m-->\e[0m\e[1m Started migration image build\e[0m\n'
# Create output directory structure
mkdir -p $output_target/$image_name
# Copy migration contents to compression target dir
2024-04-29 07:50:03 +02:00
cp -v $variantdir/migration.sh $output_target/$image_name/$image_name-migration.sh ||
cleanup_and_quit 'No primary migration script found'
2024-04-27 04:55:47 +02:00
# Copy migration related files if they are provided
if [[ -d $variantdir/migration ]]; then
cp -rv $variantdir/migration $output_target/$image_name/$image_name-migration
fi
# Compress migration files
tar -cv -I 'zstd -12 -T0 ' -f $output_target/$image_name.tar.zst -C $output_target/$image_name .
# We can just exit, no need to do a cleanup
exit 0
fi
2023-06-21 18:36:52 +02:00
# Build archlinux type image
2023-06-25 20:27:47 +02:00
if [[ $type == 'archlinux' ]]; then
2023-06-21 18:36:52 +02:00
2024-02-22 07:45:21 +01:00
# Ensure bootstrap.list exists, if not error and quit
2024-05-01 00:11:01 +02:00
# This is the mimimum requirement to perform a build and this checked first
2024-02-22 07:45:21 +01:00
if [[ ! -e $variantdir/bootstrap.list ]]; then
2024-05-01 00:11:01 +02:00
printf "\e[1;31m<#>\e[0m\e[1m The required file 'bootstrap.list' is not preset in $variantdir\e[0m\n"
2023-06-21 18:36:52 +02:00
exit 1
2023-08-10 06:44:20 +02:00
fi
2023-06-21 18:36:52 +02:00
2023-06-22 02:27:51 +02:00
printf '\e[1;34m-->\e[0m\e[1m Started Arch linux image build\e[0m\n'
2023-06-21 18:36:52 +02:00
2024-05-01 00:11:01 +02:00
printf '\e[1;34m-->\e[0m\e[1m Creating disk image\e[0m\n'
fallocate -l $build_image_size $build_image || cleanup_and_quit "Failed to create disk image at $build_image"
mkfs.btrfs -f $build_image || cleanup_and_quit "Failed to partition $build_image"
2024-02-24 14:38:33 +01:00
2024-05-01 00:11:01 +02:00
printf "\e[1;34m-->\e[0m\e[1m Mounting $build_image at $workdir\e[0m\n"
# The data is compressed to minimize writes to the disk, the actual export does not maintain this compression
mount -m -t btrfs -o loop,compress=zstd $build_image $build_image_mountpoint || cleanup_and_quit "Failed to mount disk image to $workdir"
2024-02-24 14:38:33 +01:00
2024-05-01 00:11:01 +02:00
# Create temporary Btrfs subvolume
printf "\e[1;34m-->\e[0m\e[1m Creating temporary Btrfs subvolumes at $workdir\e[0m\n"
btrfs subvolume create $workdir/ || cleanup_and_quit "Failed to create btrfs subvolume $workdir)"
2024-05-02 08:46:52 +02:00
mount --bind $workdir $workdir || cleanup_and_exit "Failed to bind mount disk $workdir"
2024-05-01 00:11:01 +02:00
btrfs subvolume create $workdir/etc || cleanup_and_quit "Failed to create btrfs subvolume $workdir/etc)"
btrfs subvolume create $workdir/var || cleanup_and_quit "Failed to create btrfs subvolume $workdir/var)"
2023-06-21 18:36:52 +02:00
# Read base package list and install base system
2024-02-22 07:45:21 +01:00
readarray bootstrap_packages < $variantdir/bootstrap.list
2023-12-11 22:11:25 +01:00
printf '\e[1;34m-->\e[0m\e[1m Installing base packages\e[0m\n'
# If pacman.conf is available in overlay, use it
2024-03-21 13:14:53 +01:00
if [[ -f $variantdir/pacman.conf ]]; then
pacstrap -c -C $variantdir/pacman.conf $workdir ${bootstrap_packages[*]} || cleanup_and_quit 'Failed to install secondary package list'
cp -v $variantdir/pacman.conf $workdir/etc/pacman.conf
else
2024-05-02 08:23:16 +02:00
pacstrap -c $workdir ${bootstrap_packages[*]} || cleanup_and_quit 'Failed to bootstrap system'
fi
2023-06-21 18:36:52 +02:00
2023-08-13 06:13:19 +02:00
# If overlay directory exists in variant copy it's contents to the temporary subvolume
2024-03-21 13:14:53 +01:00
if [[ -d $variantdir/overlay/post_bootstrap ]]; then
printf '\e[1;34m-->\e[0m\e[1m Copying overlay/post_bootstrap to root\e[0m\n'
cp -rv $variantdir/overlay/post_bootstrap/* $workdir/
2023-08-13 06:13:19 +02:00
fi
2023-08-10 06:44:20 +02:00
2024-03-21 13:14:53 +01:00
# Run post_bootstrap script if exists
if [[ -f $variantdir/extensions/post_bootstrap.sh ]]; then
printf '\e[1;34m-->\e[0m\e[1m Running post_bootstrap extension\e[0m\n'
(source $variantdir/extensions/post_bootstrap.sh)
2024-02-21 11:33:09 +01:00
fi
2023-08-13 06:13:19 +02:00
# Read package list and install secondary system components, skip if not used
2024-02-22 07:45:21 +01:00
if [[ -e $variantdir/package.list ]]; then
2023-09-19 00:23:53 +02:00
printf '\e[1;34m-->\e[0m\e[1m Installing secondary packages\e[0m\n'
2024-02-29 20:32:40 +01:00
# Mount the pacman cache
mount --bind /var/cache/pacman/pkg $workdir/var/cache/pacman/pkg
# Read package list and install
2024-02-22 07:45:21 +01:00
readarray packages < $variantdir/package.list
2024-05-02 08:23:16 +02:00
arch-chroot $workdir pacman -S --noconfirm ${packages[*]} || cleanup_and_quit 'Failed to install packages'
2024-02-29 20:32:40 +01:00
# Unmount pacman cache
2024-02-29 21:28:37 +01:00
umount -l $workdir/var/cache/pacman/pkg
2023-06-21 18:36:52 +02:00
fi
2024-03-19 08:09:49 +01:00
# If postinstall overlay directory exists in variant copy it's contents to the temporary subvolume
2024-03-21 13:14:53 +01:00
if [[ -d $variantdir/overlay/post_install ]]; then
printf '\e[1;34m-->\e[0m\e[1m Copying overlay/post_install to root\e[0m\n'
cp -rv $variantdir/overlay/post_install/* $workdir/
2024-03-19 08:09:49 +01:00
fi
2024-03-21 13:14:53 +01:00
# Run post_install script if exists
if [[ -f $variantdir/extensions/post_install.sh ]]; then
printf '\e[1;34m-->\e[0m\e[1m Running post_install extension\e[0m\n'
(source $variantdir/extensions/post_install.sh)
2024-02-21 11:33:09 +01:00
fi
2023-06-21 18:36:52 +02:00
# Remove subvolumes created by systemd
[[ -d $workdir/var/lib/portables ]] &&
2023-12-11 22:11:25 +01:00
printf '\e[1;34m-->\e[0m\e[1m Removing systemd subvolume var/lib/portables\e[0m\n'
2023-06-21 18:36:52 +02:00
btrfs subvolume delete $workdir/var/lib/portables
[[ -d $workdir/var/lib/machines ]] &&
2023-12-11 22:11:25 +01:00
printf '\e[1;34m-->\e[0m\e[1m Removing systemd subvolume var/lib/machines\e[0m\n'
2023-06-21 18:36:52 +02:00
btrfs subvolume delete $workdir/var/lib/machines
2023-09-19 00:23:53 +02:00
# Make /usr/local symlink in var
2023-12-11 22:11:25 +01:00
printf '\e[1;34m-->\e[0m\e[1m Moving dirs to var and creating symlinks\e[0m\n'
2023-09-19 00:23:53 +02:00
mv $workdir/usr/local $workdir/var/usrlocal || cleanup_and_quit 'Failed to move usr/local to var/usrlocal'
2023-11-26 11:50:38 +00:00
ln -sv ../var/usrlocal $workdir/usr/local || cleanup_and_quit 'Failed to create usrlocal symlink'
2023-09-19 00:23:53 +02:00
2023-10-24 13:11:38 +00:00
# locale symlink
2023-10-18 17:50:52 +02:00
mv $workdir/usr/lib/locale $workdir/var/usrliblocale || cleanup_and_quit 'Failed to move usr/local to var/usrlocal'
2023-10-26 18:58:35 +00:00
ln -sv ../../../var/usrliblocale $workdir/usr/lib/locale || cleanup_and_quit 'Failed to create usrlocal symlink'
2023-10-24 13:11:38 +00:00
# Opt symlink
2024-04-10 07:08:50 +02:00
mv $workdir/opt $workdir/var/ || cleanup_and_quit 'Failed to move opt to var/opt'
2023-10-24 14:52:28 +00:00
ln -sv var/opt $workdir/opt || cleanup_and_quit 'Failed to create opt symlink'
2023-10-24 13:11:38 +00:00
# srv symlink
mv $workdir/srv $workdir/var/srv || cleanup_and_quit 'Failed to move srv to var/srv'
2023-10-24 14:52:28 +00:00
ln -sv var/srv $workdir/srv || cleanup_and_quit 'Failed to create srv symlink'
2023-10-18 17:50:52 +02:00
2023-10-24 14:44:51 +00:00
# mnt symlink
mv $workdir/mnt $workdir/var/mnt || cleanup_and_quit 'Failed to move mnt to var/mnt'
2023-10-24 14:52:28 +00:00
ln -sv var/mnt $workdir/mnt || cleanup_and_quit 'Failed to create mnt symlink'
2023-10-24 14:44:51 +00:00
2024-03-03 14:44:37 +01:00
# NetworkManager system-connections symlink if installed
if [[ -d $workdir/etc/NetworkManager ]]; then
2024-03-03 15:20:12 +01:00
mv $workdir/etc/NetworkManager/system-connections $workdir/var/nm-system-connections || cleanup_and_quit 'Failed to move etc/NetworkManager/system-connections to var/nm-system-connections'
2024-03-03 14:44:37 +01:00
ln -sv ../../var/nm-system-connections $workdir/etc/NetworkManager/system-connections || cleanup_and_quit 'Failed to create nm-system-connections symlink'
fi
2024-03-29 17:40:00 +01:00
printf '\e[1;34m-->\e[0m\e[1m Creating mountpoints for shared subvolumes\e[0m\n'
# Remove the folders to ensure they are empty
rm -rf $workdir/root
rm -rf $workdir/var/lib/flatpak
# Ensure these folder exist
mkdir -pv $workdir/root
mkdir -pv $workdir/arkdep
mkdir -pv $workdir/var/lib/flatpak
printf '\e[1;34m-->\e[0m\e[1m Moving passwd, shadow and group files to usr/lib\e[0m\n'
2023-10-26 18:10:48 +00:00
# Create second passwd, group and shadow file in usr/lib and configure
for file in passwd group shadow; do
grep -v "^root:" $workdir/etc/$file > $workdir/usr/lib/$file
done
# Remove all users except for root, is typically overwritten by user overlay but
# may be used during os installation as a template
for file in passwd group shadow; do
grep "^root:" $workdir/etc/$file > $workdir/etc/$file-tmp
mv $workdir/etc/$file-tmp $workdir/etc/$file
done
# Ensure passwd/group/shadow permissions are set properly
chmod 600 $workdir/etc/shadow $workdir/usr/lib/shadow
chmod 644 $workdir/etc/{passwd,group} $workdir/usr/lib/{passwd,group}
2023-10-26 18:10:48 +00:00
#
# nss-switch.conf is added using the overlay
#
# Remove passwd/group/shadow backup files
rm $workdir/etc/{passwd-,shadow-,group-}
printf '\e[1;34m-->\e[0m\e[1m Moving CPU microcode to usr/lib\e[0m\n'
# Move CPU firmware to /usr/lib if present
mv $workdir/boot/*-ucode.img $workdir/usr/lib/
2023-06-21 18:36:52 +02:00
# Make subvolume read-only
2023-12-11 22:11:25 +01:00
printf '\e[1;34m-->\e[0m\e[1m Adding read-only property to subvolumes\e[0m\n'
2023-09-19 00:23:53 +02:00
btrfs property set -ts $workdir ro true || cleanup_and_quit 'Failed to set root to read-only'
btrfs property set -ts $workdir/etc ro true || cleanup_and_quit 'Failed to set etc to read-only'
btrfs property set -ts $workdir/var ro true || cleanup_and_quit 'Failed to set var to read-only'
2023-06-21 18:36:52 +02:00
2023-08-11 08:04:36 +02:00
# Create dir for storing the images
2024-04-27 04:55:47 +02:00
mkdir -p $output_target/$image_name
2023-08-11 08:04:36 +02:00
2024-06-21 06:29:25 +02:00
# Add update script, utilized to perform minor system changes and updates
if [[ -f $variantdir/update.sh ]]; then
printf '\e[1;34m-->\e[0m\e[1m Including update script\e[0m\n'
cp -v $variantdir/update.sh $output_target/$image_name/$image_name-update.sh ||
cleanup_and_quit 'Failed copying update script to image'
fi
2024-05-02 07:27:31 +02:00
# Generate package list
pacman -Q --root=$workdir > $output_target/$image_name.pkgs
2023-06-21 18:36:52 +02:00
# Write subvolume to image
2023-12-11 22:11:25 +01:00
printf '\e[1;34m-->\e[0m\e[1m Creating images\e[0m\n'
2023-08-13 06:13:19 +02:00
btrfs send -f $output_target/$image_name/$image_name-rootfs.img $workdir
btrfs send -f $output_target/$image_name/$image_name-etc.img $workdir/etc
btrfs send -f $output_target/$image_name/$image_name-var.img $workdir/var
2023-09-21 21:56:37 +02:00
if [[ ! -v ARKDEP_NO_TAR ]]; then
2023-12-11 22:11:25 +01:00
printf '\e[1;34m-->\e[0m\e[1m Compressing images\e[0m\n'
2023-08-14 19:08:51 +02:00
tar -cv -I 'zstd -12 -T0 ' -f $output_target/$image_name.tar.zst -C $output_target/$image_name .
2023-08-14 08:50:48 +02:00
fi
2023-06-21 18:36:52 +02:00
2024-05-02 03:11:44 +02:00
if [[ -f $variantdir/extensions/post_build.sh ]]; then
printf '\e[1;34m-->\e[0m\e[1m Running post_build extension\e[0m\n'
(source $variantdir/extensions/post_build.sh)
fi
2023-06-21 18:36:52 +02:00
cleanup_and_quit
2023-08-11 08:04:36 +02:00
2023-09-16 18:04:30 +02:00
fi
2024-08-01 18:56:35 +02:00
# No valid variant was found
printf 'No valid type set in configuration\n'
exit 2